package zh.Socket;

import java.io.*;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.net.SocketTimeoutException;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.Gravity;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

public class OtherActivity extends Activity{
	private Socket socket =null;
	private Thread mThread = null;
	private byte [] recive_buffer = new byte[1024];
	private OutputStream outputStream=null;
	private InputStream inputStream=null;
	private String str_recive;
   	private boolean is_connect = false;
	private TextView Textout = null;
   	private EditText socket_recive =null;
    private Button btn_close=null;
   	
   	private Button tv_power = null; 
   	private Button tv_mute = null; 
   	private Button tv_menu = null; 
   	private Button tv_one = null;
   	private Button tv_two = null;
   	private Button tv_three = null;
   	private Button tv_four = null;
   	private Button tv_five = null;
   	private Button tv_six = null;
   	private Button tv_seven = null;
   	private Button tv_eight = null;
   	private Button tv_nine = null;
   	private Button tv_zero = null;
   	private Button tv_sure = null;
   	private Button tv_return = null;
   	private Button tv_last = null;
   	private Button tv_next = null;
   	private Button tv_big = null; 	
   	private Button tv_small = null;
   	private Button tv_up = null;
   	private Button tv_down = null;
   	private Button tv_left = null;
   	private Button tv_right = null;
   	

   	
   	int temp_connect;
   	
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.other);
		Textout = (TextView)findViewById(R.id.Textout);
    	socket_recive =(EditText)findViewById(R.id.editText3);
      	btn_close=(Button)findViewById(R.id.button24);
    	btn_close.setEnabled(false);
    		
		//õIntentеֵ 
		Intent intent = getIntent();
		String ip_serverStr = intent.getStringExtra("ip");
		String port_serverStr = intent.getStringExtra("port");
		//IPPortֵ
		Textout.setText("TV IP Address :"+ip_serverStr);
		//Socket
		ip_serverStr.trim();
		port_serverStr.trim();
		if(ip_serverStr.length()==0||port_serverStr.length()==0)
			System.out.println("ip_server edit is empty or port_server is empty!");
		else
		{
			int port= Integer.parseInt(port_serverStr);
			System.out.println("ipַΪ:"+ip_serverStr+"portΪ:"+port);
	        try {
	    		//һSocketָ˵IPַͶ˿ں
	           	socket = new Socket();
	    		socket.connect(new InetSocketAddress(ip_serverStr, port), 1000);
	    		
	    		if(socket.isConnected()==true){
		    		outputStream = socket.getOutputStream();
					inputStream = socket.getInputStream();
					btn_close.setEnabled(true);
		    		is_connect = true;
	        	    System.out.println("connect!");
		    	}
	    		
	        	} catch (Exception e) {
		        	if(e.getClass()==SocketTimeoutException.class){
		        	    System.out.println("connect Exception!");
		        		Toast toast = Toast.makeText(OtherActivity.this,"Connect hosts abnormal.Please check whether open the network or host address errors!",Toast.LENGTH_LONG);
		        		toast.setGravity(Gravity.CENTER, 0, 0);
		        		toast.show();
		        	}
	        	e.printStackTrace();	        	
	    	    }
		}
    	btn_close.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				// TODO Auto-generated method stub
				try{
				is_connect = false;
				socket.shutdownInput();
				socket.shutdownOutput();
				socket.close();
				
				btn_close.setEnabled(false);
	    		socket_recive.setText("");	    		
				} catch (Exception e){
					e.printStackTrace();
				}				
			}
		});
        //	
    	tv_power=(Button)findViewById(R.id.button1);
        tv_power.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
        		char power = 'a'; 
        		try {
        			outputStream.write(power);
        			outputStream.flush();
					socket_recive.setText("");
        		}
        		catch (Exception e) {
        			e.printStackTrace();
        		}
        	}
        }
        );	
        //
        tv_mute=(Button)findViewById(R.id.button2);
        tv_mute.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
        		char mute = 'o'; 
        		try {
        			outputStream.write(mute);
        			outputStream.flush();
					socket_recive.setText("");
        		}
        		catch (Exception e) {
        			e.printStackTrace();
        		}
        	}
        }
        );	        
        //˵
        tv_menu=(Button)findViewById(R.id.button3);
        tv_menu.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
        		char menu = 'q'; 
        		try {
        			outputStream.write(menu);
        			outputStream.flush();
					socket_recive.setText("");
        		}
        		catch (Exception e) {
        			e.printStackTrace();
        		}
        	}
        }
        );	
        //Ƶ1
        tv_one=(Button)findViewById(R.id.button4);
        tv_one.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
        		char one = '1'; 
        		try {
        			outputStream.write(one);
        			outputStream.flush();
					socket_recive.setText("");
        		}
        		catch (Exception e) {
        			e.printStackTrace();
        		}
        	}
        }
        );	
        //Ƶ2
        tv_two=(Button)findViewById(R.id.button5);
        tv_two.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
        		char two = '2'; 
        		try {
        			outputStream.write(two);
        			outputStream.flush();
					socket_recive.setText("");
        		}
        		catch (Exception e) {
        			e.printStackTrace();
        		}
        	}
        }
        );	
        //Ƶ3
        tv_three=(Button)findViewById(R.id.button6);
        tv_three.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
        		char three = '3'; 
        		try {
        			outputStream.write(three);
        			outputStream.flush();
					socket_recive.setText("");
        		}
        		catch (Exception e) {
        			e.printStackTrace();
        		}
        	}
        }
        );	
        //Ƶ4
        tv_four=(Button)findViewById(R.id.button7);
        tv_four.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
        		char four = '4'; 
        		try {
        			outputStream.write(four);
        			outputStream.flush();
					socket_recive.setText("");
        		}
        		catch (Exception e) {
        			e.printStackTrace();
        		}
        	}
        }
        );	
        //Ƶ5
        tv_five=(Button)findViewById(R.id.button8);
        tv_five.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
        		char five = '5'; 
        		try {
        			outputStream.write(five);
        			outputStream.flush();
					socket_recive.setText("");
        		}
        		catch (Exception e) {
        			e.printStackTrace();
        		}
        	}
        }
        );	
        //Ƶ6
        tv_six=(Button)findViewById(R.id.button9);
        tv_six.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
        		char six = '6'; 
        		try {
        			outputStream.write(six);
        			outputStream.flush();
					socket_recive.setText("");
        		}
        		catch (Exception e) {
        			e.printStackTrace();
        		}
        	}
        }
        );	
        //Ƶ7
        tv_seven=(Button)findViewById(R.id.button10);
        tv_seven.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
        		char seven = '7'; 
        		try {
        			outputStream.write(seven);
        			outputStream.flush();
					socket_recive.setText("");
        		}
        		catch (Exception e) {
        			e.printStackTrace();
        		}
        	}
        }
        );	
        //Ƶ8
        tv_eight=(Button)findViewById(R.id.button11);
        tv_eight.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
        		char eight = '8'; 
        		try {
        			outputStream.write(eight);
        			outputStream.flush();
					socket_recive.setText("");
        		}
        		catch (Exception e) {
        			e.printStackTrace();
        		}
        	}
        }
        );	
        //Ƶ9
        tv_nine=(Button)findViewById(R.id.button12);
        tv_nine.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
        		char nine = '9'; 
        		try {
        			outputStream.write(nine);
        			outputStream.flush();
					socket_recive.setText("");
        		}
        		catch (Exception e) {
        			e.printStackTrace();
        		}
        	}
        }
        );	
        //Ƶ0
        tv_zero=(Button)findViewById(R.id.button13);
        tv_zero.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
        		char zero = '0'; 
        		try {
        			outputStream.write(zero);
        			outputStream.flush();
					socket_recive.setText("");
        		}
        		catch (Exception e) {
        			e.printStackTrace();
        		}
        	}
        }
        );	
        //ȷ
        tv_sure=(Button)findViewById(R.id.button14);
        tv_sure.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
        		char sure = 'g'; 
        		try {
        			outputStream.write(sure);
        			outputStream.flush();
					socket_recive.setText("");
        		}
        		catch (Exception e) {
        			e.printStackTrace();
        		}
        	}
        }
        );	
        //
        tv_return=(Button)findViewById(R.id.button15);
        tv_return.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
        		char Return = 'f'; 
        		try {
        			outputStream.write(Return);
        			outputStream.flush();
					socket_recive.setText("");
        		}
        		catch (Exception e) {
        			e.printStackTrace();
        		}
        	}
        }
        );	
        //ϸĿ
        tv_last=(Button)findViewById(R.id.button16);
        tv_last.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
        		char last = 'd'; 
        		try {
        			outputStream.write(last);
        			outputStream.flush();
					socket_recive.setText("");
        		}
        		catch (Exception e) {
        			e.printStackTrace();
        		}
        	}
        }
        );	
        //¸Ŀ
        tv_next=(Button)findViewById(R.id.button17);
        tv_next.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
        		char next = 'e'; 
        		try {
        			outputStream.write(next);
        			outputStream.flush();
					socket_recive.setText("");
        		}
        		catch (Exception e) {
        			e.printStackTrace();
        		}
        	}
        }
        );	
        //
        tv_big=(Button)findViewById(R.id.button18);
        tv_big.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
        		char big = 'b'; 
        		try {
        			outputStream.write(big);
        			outputStream.flush();
					socket_recive.setText("");
        		}
        		catch (Exception e) {
        			e.printStackTrace();
        		}
        	}
        }
        );	
        //С
        tv_small=(Button)findViewById(R.id.button19);
        tv_small.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
        		char small = 'c'; 
        		try {
        			outputStream.write(small);
        			outputStream.flush();
					socket_recive.setText("");
        		}
        		catch (Exception e) {
        			e.printStackTrace();
        		}
        	}
        }
        );	
        //ѡ
        tv_up=(Button)findViewById(R.id.button20);
        tv_up.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
        		char up = 'h'; 
        		try {
        			outputStream.write(up);
        			outputStream.flush();
					socket_recive.setText("");
        		}
        		catch (Exception e) {
        			e.printStackTrace();
        		}
        	}
        }
        );	
        //ѡ
        tv_down=(Button)findViewById(R.id.button21);
        tv_down.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
        		char down = 'i'; 
        		try {
        			outputStream.write(down);
        			outputStream.flush();
					socket_recive.setText("");
        		}
        		catch (Exception e) {
        			e.printStackTrace();
        		}
        	}
        }
        );	
        //ѡ
        tv_left=(Button)findViewById(R.id.button22);
        tv_left.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
        		char left = 'j'; 
        		try {
        			outputStream.write(left);
        			outputStream.flush();
					socket_recive.setText("");
        		}
        		catch (Exception e) {
        			e.printStackTrace();
        		}
        	}
        }
        );	
        //ѡ
        tv_right=(Button)findViewById(R.id.button23);
        tv_right.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
        		char right = 'k'; 
        		try {
        			outputStream.write(right);
        			outputStream.flush();
					socket_recive.setText("");
        		}
        		catch (Exception e) {
        			e.printStackTrace();
        		}
        	}
        }
        );	
        
  	  mThread = new Thread(mRunnable);
  	  mThread.start();	
	}
	//߳:Ϣ
	private Runnable	mRunnable	= new Runnable() 
	{
		public void run()
		{
			
			while (true)
			{
				try
				{
					if(is_connect){
						System.out.println("is_connect is :"+is_connect);	
						temp_connect=inputStream.read(recive_buffer,0,recive_buffer.length);
						if(temp_connect!=-1){
							str_recive=new String(recive_buffer,0,temp_connect);
							str_recive.trim();
							System.out.println("recive datas!"+temp_connect+str_recive);	
						}
						else {
							socket.shutdownInput();
							socket.shutdownOutput();
							inputStream.close();
							outputStream.close();
							socket.close();
							is_connect=false;
						}
						// Ϣ
						mHandler.sendMessage(mHandler.obtainMessage());
					}
					Thread.sleep(100);	
				}
				catch (Exception e)
				{
					e.printStackTrace();
				}
			
			}
		}
	};
		
	Handler		mHandler	= new Handler() 
	{										
		  public void handleMessage(Message msg)										
		  {											
			  super.handleMessage(msg);	
			  
			  // ˢ											
			  try											
			  {	
				  System.out.println("mHandler!");	
				  if(temp_connect==-1){
					  	btn_close.setEnabled(false);
			    		socket_recive.setText("");
				  }
				  else {
					  	socket_recive.setText(str_recive);	
				  }  
			  }											
			  catch (Exception e)											
			  {																					
				  e.printStackTrace();											
			  }										
		  }									
	 };  
	
}


		

	





